#include-once
#include <GDIPlus.au3>

; #BEISPIEL# ====================================================================================================================
; Author ........: Mars
; Modified ......:
; ===============================================================================================================================

Opt('GUIOnEventMode', 1)
_GDIPlus_Startup()

Global $bExit = False
Global $hGUI = GUICreate('Test', 512, 512)
Global $hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
Global $hIMG = _GDIPlus_ImageLoadFromFile('Mona.jpg')
Global $t = TimerInit(), $iTimer, $iTime, $iFrameTimer = TimerInit()

GUISetOnEvent(-3, 'EVENT', $hGUI)
GUISetState(@SW_SHOW, $hGUI)

While Sleep(10) And Not $bExit
	$iTimer = TimerInit()
	_GDIPlus_BitmapMove($hIMG, 5 * Sin(TimerDiff($t) / 1000) + 3 * Cos(TimerDiff($t) / 3000), 5 * Cos(TimerDiff($t) / 1000) + 3 * Sin(TimerDiff($t) / 7000))
	$iTime = (TimerDiff($iTimer) + $iTime * 19) / 20
	If TimerDiff($iFrameTimer) > 1000 Then
		WinSetTitle($hGUI, '', 'BitmapMove: ' & Round($iTime, 1) & ' ms')
		$iFrameTimer = TimerInit()
	EndIf
	_GDIPlus_GraphicsDrawImage($hGFX, $hIMG, 0, 0)
WEnd

_GDIPlus_ImageDispose($hIMG)
_GDIPlus_GraphicsDispose($hGFX)
_GDIPlus_Shutdown()

Func EVENT()
	Switch @GUI_CtrlId
		Case -3
			$bExit = True
	EndSwitch
EndFunc

; #FUNCTION# ====================================================================================================================
; Author ........: Mars
; Modified ......:
; ===============================================================================================================================
Func _GDIPlus_BitmapMove($hBMP, $dx, $dy)
	$dx = Round($dx, 0) ; Ich würde ja gerne einfach int als Datentyp
	$dy = Round($dy, 0) ; festlegen, aber das läuft ja nicht...
	Local $iW = DllCall($__g_hGDIPDll, 'int', 'GdipGetImageWidth', 'handle', $hBMP, 'uint*', 0)[2]
	Local $iH = DllCall($__g_hGDIPDll, 'int', 'GdipGetImageHeight', 'handle', $hBMP, 'uint*', 0)[2]
	Local $hClone = DllCall($__g_hGDIPDll, 'int', 'GdipCloneBitmapAreaI', 'int', 0, 'int', 0, 'int', $iW, 'int', $iH, 'int', 0x00021808, 'handle', $hBMP, 'handle*', 0)[7]
	Local $hGFX = DllCall($__g_hGDIPDll, 'int', 'GdipGetImageGraphicsContext', 'handle', $hBMP, 'handle*', 0)[2]
	Local $iX = Int($dx / $iW) * $iW + $dx, $iY = Int($dy / $iH) * $iH + $dy, $tX = $dx < 0 ? $iW : -$iW, $tY = $dy < 0 ? $iH : -$iH
	DllCall($__g_hGDIPDll, 'int', 'GdipDrawImageI', 'handle', $hGFX, 'handle', $hClone, 'int', $iX, 'int', $iY)
	DllCall($__g_hGDIPDll, 'int', 'GdipDrawImageI', 'handle', $hGFX, 'handle', $hClone, 'int', $iX + $tX, 'int', $iY)
	DllCall($__g_hGDIPDll, 'int', 'GdipDrawImageI', 'handle', $hGFX, 'handle', $hClone, 'int', $iX, 'int', $iY + $tY)
	DllCall($__g_hGDIPDll, 'int', 'GdipDrawImageI', 'handle', $hGFX, 'handle', $hClone, 'int', $iX + $tX, 'int', $iY + $tY)
	DllCall($__g_hGDIPDll, 'int', 'GdipDeleteGraphics', 'handle', $hGFX)
	DllCall($__g_hGDIPDll, 'int', 'GdipDisposeImage', 'handle', $hClone)
EndFunc